local L,SN,ST = DXE.L,DXE.SN,DXE.ST

------------------------
-- Morchok
------------------------
do
	local data = {
		version = 1,
		key = "Morchok",
		zone = L.zone["Dragon Soul"],
		category = L.zone["Dragon Soul"],
		name = L.npc_dragonsoul["Morchok"],
		triggers = {
			scan = {
				55265, --Morchok
			},
		},
		onactivate = {
			tracing = {
				55265, --Morchok
			},
			tracerstart = true,
			combatstop = true,
			defeat = 55265, --Morchok
		},
		enrage = {
			time10n = 1080,
			time25n = 1080,
			time10h = 1080,
			time25h = 1080,
		},
		userdata = {
			crushtext = "",
		},
		windows = {
		},
		timers = {
		},
		announces = {
		},
		raidicons = {
		},
		arrows = {
		},
		onstart = {
		},
		alerts = {
			crushwarn = {
				varname = format(L.alert["%s Warning"],SN[103687]),
				type = "simple",
				text = "<woundtext>",
				time = 3,
				color1 = "WHITE",
				icon = ST[103687],
			},
			stompwarn = {
				varname = format(L.alert["%s Warning"],SN[103414]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[103414]),
				time = 3,
				flashtime = 3,
				color1 = "GREEN",
				icon = ST[103414],
			},
			stompcd = {
				varname = format(L.alert["%s Cooldown"],SN[103414]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[103414]),
				time = 30,
				flashtime = 5,
				color1 = "GREEN",
				icon = ST[103414],
			},
			orbcd = {
				varname = format(L.alert["%s Cooldown"],SN[103640]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[103640]),
				time = 30,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[103640],
			},
			orbwarn = {
				varname = format(L.alert["%s Casting"],SN[103640]),
				type = "simple",
				text = format("%s: &upvalue&!",SN[103640]),
				text2 = format(L.alert["%s Casting"],SN[103640]),
				time = 3,
				color1 = "PURPLE",
				icon = ST[103640],
			},--[[
			orbself = {
				varname = format(L.alert["%s on self"],SN[103640]),
				type = "simple",
				text = format("%s: %s!",SN[103640],L.alert["YOU"]),
				time = 3,
				color1 = "PURPLE",
				icon = ST[103640],
				flashscreen = true,
			},]]
			bloodcd = {
				varname = format(L.alert["%s Cooldown"],SN[35331]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[35331]),
				time = 30,
				flashtime = 5,
				color1 = "BLACK",
				icon = ST[103179],
			},
			bloodwarn = {
				varname = format(L.alert["%s Warning"],SN[35331]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[35331]),
				time = 3,
				flashtime = 3,
				color1 = "BLACK",
				icon = ST[103179],
			},
			blooddur = {
				varname = format(L.alert["%s Duration"],SN[35331]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[35331]),
				time = 20,
				flashtime = 5,
				color1 = "BLACK",
				icon = ST[103179],
			},
		},
		events = {
			-- Crush Armor on Tanks
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED_DOSE",
				spellname = 103687,
				execute = {
					{
						"expect",{"#11#",">=","2"},
						"set",{crushtext = format(L.alert["%s: %s x %s"],"#5#",SN[103687],"#11#")},
						"alert","crushwarn",
					},
				},
			},
			-- Stomp
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname= 103414,
				execute = {
					{
						"quash","stompcd",
						"alert","stompcd",
						"alert","stompwarn",
					},
				},
			},
			-- Twilight Orb (maybe "targetted")

			-- Fragments (neccessary?)

			-- Black Blood (start warn after 2s?)
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 103179,
				execute = {
					{
						"quash","bloodcd",
						"alert","bloodcd",
						"alert","bloodwarn",
					},
				},
			},

		},
	}

	DXE:RegisterEncounter(data)
end
