local L,SN,ST = DXE.L,DXE.SN,DXE.ST

------------------------
-- Zon'ozz
------------------------
do
	local data = {
		version = 1,
		key = "Warlord Zon'ozz",
		zone = L.zone["Dragon Soul"],
		category = L.zone["Dragon Soul"],
		name = L.npc_dragonsoul["Warlord Zon'ozz"],
		triggers = {
			scan = {
				55308, --Warlord Zon'ozz
			},
		},
		onactivate = {
			tracing = {
				55308, --Warlord Zon'ozz
			},
			tracerstart = true,
			combatstop = true,
			defeat = 55308,
		},
		enrage = {
			time10n = 1080,
			time25n = 1080,
			time10h = 1080,
			time25h = 1080,
		},
		userdata = {
			shadowunits = {type = "container", wipein = 5},
		},
		windows = {
			proxwindow = true,
			proxrange = 10,
		},
		announces = {
			shadowsay = {
				varname = format(L.alert["%s on self"],SN[104600]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[104600]),
			},
		},
		raidicons = {
			shadowicon = {
				varname = SN[104600],
				type = "MULTIFRIENDLY",
				persist = 8, --???
				reset = 2,
				unit = "#5#",
				icon = 2,
				total = 2, --???
			},
		},
		arrows = {
		},
		timers = {
			shadows = {
				{
					"quash","shadowcd",
					"alert","shadowcd",
					"alert","shadowwarn",
				},
			},
		},
		onstart = {
		},
		alerts = {
			shadowcd = {
				varname = format(L.alert["%s Cooldown"],SN[104600]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[104600]),
				time = 30,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[104600],
			},
			shadowwarn = {
				varname = format(L.alert["%s Warning"],SN[104600]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[104600],"&list|shadowunits&"),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				icon = ST[104600],
			},
			shadowself = {
				varname = format(L.alert["%s Warning on self"],SN[104600]),
				type = "centerpopup",
				text = format(L.alert["%s on %s"],SN[104600],L.alert["YOU"]),
				time = 8,
				flashtime = 8,
				color1 = "PURPLE",
				icon = ST[104600],
			},
			voidcd = {
				varname = format(L.alert["%s Cooldown"],SN[104002]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[104002]),
				time = 30,
				flashtime = 5,
				color1 = "BLUE",
				icon = ST[104002],
			},
			voidwarn = {
				varname = format(L.alert["%s Warning"],SN[104002]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[104002]),
				time = 3,
				flashtime = 3,
				color1 = "BLUE",
				icon = ST[104002],
			},
		},
		events = {
			-- Disrupting Shadows
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 103687,
				execute = {
					{
						"insert",{"shadowunits","#5#"},
						"canceltimer","shadows",
						"scheduletimer",{"shadows",0.2},
						"raidicon","shadowicon",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","shadowsay",
						"alert","shadowself",
					},
				},
			},
			-- Void of the Unmaking
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellname = 104002,
				execute = {
					{
						"quash","voidcd",
						"alert","voidcd",
						"alert","voidwarn",
					},
				},
			},
			-- perhaps removal of focused anger?
		},
	}

	DXE:RegisterEncounter(data)
end
